'------------------------------------------------------------------------------
' "Find", "Replace", "Go to Line" Dialog box handlers for use with EDM32.INC
'
' Compiled with PBWIN 70. SDK code example.
'
' Original bits of code from...
' -> Adam Ritchie ( edm32 specifics, dialog templates & handlers )
' -> Borje Hagsten ( Find combobox handler, 3 sections, & MsgBoxApi )
' Big thanks to both!
'
' Here is all their hard work stitched together as a demo. Thought others
' would find this handy for their own EDM32 editor projects.
'
' Jules Marchildon, May 16th, 2003
' No warranty applies, use at own risk!
'------------------------------------------------------------------------------
#Compile Exe
#Include "WIN32API.INC"
'#INCLUDE "BS_EDM32.INC" 'modified for use with Basic Stamp II
#Include "EDM32.INC" 'modified for use with Basic Stamp II

#Resource "emd.pbr" 'resource, used dialog templates

'---Main Window Identifiers
%IDC_FINDDLG = 102 ' Find button
%IDC_CANCEL = 103 ' Exit button
%IDC_REPLACEDLG = 104 ' Replace button
%IDC_EDIT = 200 ' one instance of EDM32.INC control
%IDC_FINDNEXT = 105 ' Find Next button
%IDC_GOTOLINE = 106 ' Go to line button

'---MYFIND dialog ID's --------------------------------------------------------
%IDC_FIND_LABEL1 = 4000 ' Label "Find What:"
%IDC_FIND_COMBOBOX1 = 4001 ' Combobox
%IDC_FIND_CHECK1 = 4002 ' AutoCheckbox "Match Whole Words"
%IDC_FIND_CHECK2 = 4003 ' AutoCheckbox "Match Case"
%IDC_FIND_GROUPBOX1 = 4004 ' Groupbox "Direction"
%IDC_FIND_RADIO1 = 4005 ' AutoRadiobutton "Up"
%IDC_FIND_RADIO2 = 4006 ' AutoRadiobutton "down"
%IDC_FIND_BUTTON1 = 4007 ' default pushbutton "Find Next"
%IDC_FIND_BUTTON2 = 4008 ' pushbutton "Close"

'MYREPLACE dialog ID's
%IDC_REPLACE_LABEL1 = 4100 ' Label "Find What:"
%IDC_REPLACE_COMBOBOX1 = 4101 ' Combobox 1
%IDC_REPLACE_LABEL2 = 4102 ' Label "Replace With:"
%IDC_REPLACE_COMBOBOX2 = 4103 ' Combobox 2
%IDC_REPLACE_CHECK1 = 4104 ' AutoCheckbox "Match Whole Words"
%IDC_REPLACE_CHECK2 = 4105 ' AutoCheckbox "Match Case"
%IDC_REPLACE_BUTTON1 = 4106 ' default pushbutton "Find Next"
%IDC_REPLACE_BUTTON2 = 4107 ' pushbutton "Replace"
%IDC_REPLACE_BUTTON3 = 4108 ' pushbutton "Replace All"
%IDC_REPLACE_BUTTON4 = 4109 ' pushbutton "Close"

'MYGOTOLINE dialog ID's
%IDC_GOTO_GROUPBOX1 = 4200 ' Groupbox
%IDC_GOTO_LABEL1 = 4201 ' Label "Last Line"
%IDC_GOTO_LABEL2 = 4202 ' Label #
%IDC_GOTO_LABEL3 = 4203 ' Label "Current Line"
%IDC_GOTO_LABEL4 = 4204 ' Label #
%IDC_GOTO_LABEL5 = 4205 ' Label "Go To Line
%IDC_GOTO_EDITBOX1 = 4206 ' Editbox, numbers only
%IDC_GOTO_BUTTON1 = 4207 ' default button "OK"
%IDC_GOTO_BUTTON2 = 4208 ' button "Cancel"
'------------------------------------------------------------------------------

'---
Global ghMain As Long ' main application window
Global ghEdit As Long ' EDM32 control
' note to self: replace ghEdit with GetEdit() in MDI

Global ghFindDlg As Long ' prevent multiple Find dialogs
Global ghReplaceDlg As Long ' prevent multiple Replace dialogs

Global gFindNextTxt As String ' save last find text
Global gFindTxt() As String ' array of recent "find text" for combobox, Find dlg
Global gFindRepTxt() As String ' array of recent "Find text" for combobox, Replace dlg
Global gRepWithTxt() As String ' array of recent "Replace with" for combobox, Replace dlg
Global gbFindDir As Long ' Find search direction up/down
Global gbFindMcase As Long ' Find dlg mCase option
Global gbFindWhole As Long ' Find dlg whole option
Global gbRepMcase As Long ' Replace dlg mCase option
Global gbRepWhole As Long ' Replace dlg whole option
'---
Declare Sub CreateMainAppButtons(ByVal hWnd As Long)
Declare Function MsgBoxApi(ByVal hParent As Long, ByVal sMsg As String, ByVal sTitle As String, ByVal dwFlags As Dword) As Long
Declare Function SearchFindDlgProc(ByVal hDlg As Long, ByVal wMsg As Long,ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function SearchReplaceDlgProc(ByVal hDlg As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function GotoLineDlgProc(ByVal hDlg As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Sub UpdateComboList(ByVal MainhWnd As Long, ByVal comboID As Long, ByVal strTxt As String)

'------------------------------------------------------------------------------
'
'------------------------------------------------------------------------------
Function WinMain(ByVal hInstance As Long,ByVal hPrevInstance As Long, _
ByVal lpCmdLine As Asciiz Ptr,ByVal lCmdShow As Long) As Long

Local hWnd As Long,rc As RECT,twcx As WNDCLASSEX
Local Style As Dword,StyleEx As Dword,hRichEditDLL As Long
Local szCaption As Asciiz*255,szClassName As Asciiz*255
Local tMsg As tagMsg

  'Register the Main application window...
  szClassName = "WINMAINAPP"
  twcx.cbSize = SizeOf(twcx)
  twcx.style = 0
  twcx.lpfnWndProc = CodePtr(WinMainWndProc)
  twcx.cbClsExtra = 0
  twcx.cbWndExtra = 0
  twcx.hInstance = hInstance
  twcx.hIcon = LoadIcon(%NULL,ByVal %IDI_APPLICATION)
  twcx.hCursor = LoadCursor(%NULL,ByVal %IDC_ARROW)
  twcx.hbrBackground = %COLOR_MENU +1
  twcx.lpszMenuName = %NULL
  twcx.lpszClassName = VarPtr(szClassName)
  twcx.hIconSm = LoadIcon(%NULL,ByVal %IDI_APPLICATION)
  Call RegisterClassEx(twcx)

  szCaption = "Find, Replace & Go To -Demo:"
  Style = %WS_OVERLAPPED Or %WS_CAPTION Or %WS_SYSMENU Or %WS_MINIMIZEBOX
  StyleEx = %WS_EX_WINDOWEDGE
  Call SetRect(rc,100,100,510,374)

   'Create the Main application window...
   hWnd = CreateWindowEx(StyleEx,"WINMAINAPP",szCaption,Style, _
   rc.nLeft,rc.nTop,rc.nRight,rc.nBottom,_
   %HWND_DESKTOP,%NULL,hInstance, ByVal %NULL)

   ghMain = hWnd

   Call ShowWindow(hWnd,%SW_NORMAL)
   Call UpdateWindow(hWnd)

   While IsTrue GetMessage(tMsg, ByVal %NULL, 0, 0)
   If IsFalse IsDialogMessage( GetActiveWindow(), tMsg ) Then
   Call TranslateMessage(tMsg)
   Call DispatchMessage(tMsg)
   End If
   Wend

   Function = tMsg.wParam
End Function

'------------------------------------------------------------------------------
'
'------------------------------------------------------------------------------
Function WinMainWndProc(ByVal hWnd As Long,ByVal wMsg As Long,ByVal wParam As Long,ByVal lParam As Long) As Long

Local hInst As Long
Local rc As RECT

hInst = GetModuleHandle(ByVal %NULL)

Select Case (wMsg)

Case %WM_CREATE
Call CreateMainAppButtons(hWnd)

'--Create the custom edit control, Borje's fine edm32.inc work...
Call SetRect(rc,8,8,490,280)
ghEdit = CreateEdm32edit( hWnd, _
%IDC_EDIT, _
rc.nLeft,rc.nTop,rc.nRight,rc.nBottom, _
%WS_CHILD Or %WS_VISIBLE Or %WS_HSCROLL Or _
%WS_VSCROLL Or %WS_TABSTOP Or %WS_BORDER, _
%WS_EX_CLIENTEDGE, 0 )

Call edmSetFontEditor( ghEdit, "Courier New", 11,0,0,0 )
Call SendMessage( ghEdit, %EDM_SETBMCOLOR, RGB(0,0,255), 0 )
Call SendMessage( ghEdit, %EDM_SETKBSHORTCUTS, %TRUE, 0 )

Call SendMessage( ghEdit, %EDM_SETKWCASE, 1, 0 )

'################### YOU WILL NEED TO CHANGE PATH/FILE ############
'
'load the edit control with text from the file, (edm32 does
'not support EDM_SETTEXT message handler at this time)
Dim fname As String
fname = "c:\projects\based\infotext.bs2" '<basic stamp II file>
Call SendMessage( ghEdit, %EDM_LOADFILE, ByVal StrPtr(fname), 0 )
'
'##################################################################
'--simulate adding a few bookmarks from a project ini file
Call SendMessage( ghEdit, %EDM_SETBMARK, 0, 10 )
Call SendMessage( ghEdit, %EDM_SETBMARK, 0, 20 )
Call SendMessage( ghEdit, %EDM_SETBMARK, 0, 30 )
Case %WM_COMMAND
Select Case LoWrd(wParam)

Case %IDC_FINDDLG
If HiWrd(wParam) = %BN_CLICKED Then
If IsTrue(ghFindDlg) Then
Call SetActiveWindow(ghFindDlg)
Function = 0:Exit Function
Else
'put up our modeless dialog box...
ghFindDlg = CreateDialog( hInst,"MYFIND",hWnd,CodePtr(SearchFindDlgProc) )
End If
End If

Case %IDC_FINDNEXT
If HiWrd(wParam) = %BN_CLICKED Then
Local Pos As Long
If Len(gFindNextTxt) > 0 Then
Pos = edmTxtFindNext(ghEdit, gFindNextTxt, gbFindDir, gbFindMcase, gbFindWhole, 1)
If Pos = 0 Then
Call MsgBoxApi( hWnd, "Match not found","Find Next", %MB_OK Or %MB_APPLMODAL Or %MB_ICONQUESTION)
End If
Else
Call SendMessage( hWnd, %WM_COMMAND, MakLng(%IDC_FINDDLG,0),GetDlgItem(hWnd,%IDC_FINDDLG))
End If
End If

Case %IDC_REPLACEDLG
If HiWrd(wParam) = %BN_CLICKED Then
If IsTrue(ghReplaceDlg) Then
Call SetActiveWindow( ghReplaceDlg)
Function = 0:Exit Function
Else
'put up our modeless dialog box.
ghReplaceDlg = CreateDialog(hInst,"MYREPLACE",hWnd, CodePtr(SearchReplaceDlgProc))
End If
End If

Case %IDC_GOTOLINE
If HiWrd(wParam) = %BN_CLICKED Then
'---
If IsTrue(ghFindDlg) Then Call EnableWindow( ghFindDlg, %FALSE)
If IsTrue(ghReplaceDlg) Then Call EnableWindow( ghReplaceDlg, %FALSE)
' put up our modal dialog box
Call Dialogbox( hInst, "MYGOTOLINE", hWnd, CodePtr(GotoLineDlgProc))
'
If IsTrue(ghFindDlg) Then Call EnableWindow( ghFindDlg, %TRUE)
If IsTrue(ghReplaceDlg) Then Call EnableWindow( ghReplaceDlg, %TRUE)
'---
End If

'---
Case %IDC_CANCEL,%IDCANCEL
If HiWrd(wParam) = %BN_CLICKED Then
Call SendMessage(hWnd,%WM_CLOSE,0,0)
End If

End Select

Case %WM_CLOSE
Call SendMessage(hWnd,%WM_DESTROY,0,0)

Case %WM_DESTROY
Call PostQuitMessage(0)

End Select
Function = DefWindowProc(hWnd,wMsg,wParam,lParam)
End Function

'------------------------------------------------------------------------------
'
'------------------------------------------------------------------------------
Sub CreateMainAppButtons(ByVal hWnd As Long)

Local hCtl As Long,hInst As Long,Style As Dword,StyleEx As Dword
Local szCaption As Asciiz*255,rc As RECT,rcm As RECT
Local cap As Long, bor As Long,tm As Long,gap As Long

hInst = GetModuleHandle(ByVal %NULL)

Call GetClientRect(hWnd,rcm)
cap = GetSystemMetrics(%SM_CYCAPTION)
bor = GetSystemMetrics(%SM_CXBORDER)
tm = 6
gap = 6

'---
szCaption = "Find Next"
Call SetRect(rc,rcm.nRight+bor-tm-410-gap*2,rcm.nBottom-cap-12,80,30)
Style = %WS_CHILD Or %WS_CLIPSIBLINGS Or %WS_TABSTOP Or _
%WS_VISIBLE Or %BS_PUSHBUTTON
StyleEx = 0
hCtl = CreateWindowEx(StyleEx, "BUTTON", szCaption,Style, _
rc.nLeft,rc.nTop,rc.nRight,rc.nBottom, _
hWnd, %IDC_FINDNEXT, hInst, ByVal %NULL)
'---
szCaption = "GoTo"
Call SetRect(rc,rcm.nRight+bor-tm-330-gap,rcm.nBottom-cap-12,80,30)
Style = %WS_CHILD Or %WS_CLIPSIBLINGS Or %WS_TABSTOP Or _
%WS_VISIBLE Or %BS_PUSHBUTTON
StyleEx = 0
hCtl = CreateWindowEx(StyleEx, "BUTTON", szCaption,Style, _
rc.nLeft,rc.nTop,rc.nRight,rc.nBottom, _
hWnd, %IDC_GOTOLINE, hInst, ByVal %NULL)
'---
szCaption = "Find"
Call SetRect(rc,rcm.nRight+bor-tm-240-gap*2,rcm.nBottom-cap-12,80,30)
Style = %WS_CHILD Or %WS_CLIPSIBLINGS Or %WS_TABSTOP Or _
%WS_VISIBLE Or %BS_PUSHBUTTON
StyleEx = 0
hCtl = CreateWindowEx(StyleEx, "BUTTON", szCaption,Style, _
rc.nLeft,rc.nTop,rc.nRight,rc.nBottom, _
hWnd, %IDC_FINDDLG, hInst, ByVal %NULL)
'---
szCaption = "Replace"
Call SetRect(rc,rcm.nRight+bor-tm-160-gap,rcm.nBottom-cap-12,80,30)
Style = %WS_CHILD Or %WS_CLIPSIBLINGS Or %WS_TABSTOP Or _
%WS_VISIBLE Or %BS_PUSHBUTTON
StyleEx = 0
hCtl = CreateWindowEx(StyleEx, "BUTTON", szCaption,Style, _
rc.nLeft,rc.nTop,rc.nRight,rc.nBottom, _
hWnd, %IDC_REPLACEDLG, hInst, ByVal %NULL)
'---
szCaption = "Exit"
Call SetRect(rc,rcm.nRight+bor-tm-80,rcm.nBottom-cap-12,80,30)
Style = %WS_CHILD Or %WS_CLIPSIBLINGS Or %WS_TABSTOP Or _
%WS_VISIBLE Or %BS_PUSHBUTTON
StyleEx = 0
hCtl = CreateWindowEx(StyleEx, "BUTTON", szCaption,Style, _
rc.nLeft,rc.nTop,rc.nRight,rc.nBottom, _
hWnd, %IDC_CANCEL, hInst, ByVal %NULL)

End Sub

'------------------------------------------------------------------------------
' Special messagebox procedure - also fixes fp register bug in Win2K (Win95/98?)
' Call like: MSGBOXAPI CBHNDL, "Ok", "Title", %MB_OK OR %MB_ICONEXCLAMATION
'------------------------------------------------------------------------------
Function MsgBoxApi (ByVal hParent As Long, ByVal sMsg As String, _
ByVal sTitle As String, ByVal dwFlags As Dword) As Long

#Register None
If hParent = 0 Then hParent = GetFocus()

Function = MessageBox(hParent, ByVal StrPtr(sMsg), ByVal StrPtr(sTitle), dwFlags)
CtrlWrd% = &B0001001100111111
Asm FLDCW CtrlWrd% ; this guarantees extended precision

End Function

'------------------------------------------------------------------------------
' Populate and maintain a combobox with the latest 20 searched items
' Belongs to Find Dialog box.
'------------------------------------------------------------------------------
Sub UpdateComboList(ByVal MainhWnd As Long, ByVal comboID As Long, ByVal strTxt As String)

If Len(strTxt) Then

Local comboCtrl As Long, cbListCount As Long

comboCtrl = GetDlgItem(MainhWnd, comboID) '<- get cb's hWnd
cbListCount = SendMessage(comboCtrl, %CB_GETCOUNT, 0, 0) '<- get cb's list count

If 0 < cbListCount Then
Local cmpTxt As String, cb As Long

For cb = 0 To cbListCount - 1 'Loop through existing items
cmpTxt = Space$(SendMessage(comboCtrl, %CB_GETLBTEXTLEN, cb, 0) + 1)
Call SendMessage(comboCtrl, %CB_GETLBTEXT, cb, StrPtr(cmpTxt))
cmpTxt = Left$(cmpTxt, Len(cmpTxt) -1) 'remove chr$(0)

If cmpTxt = strTxt Then 'if already there - delete and then insert at top
Call SendMessage(comboCtrl, %CB_DELETESTRING, cb, 0)
Exit For
End If
Next cb
End If
'insert new items at the top of the list
Call SendMessage(comboCtrl, %CB_INSERTSTRING, 0, ByVal StrPtr(strTxt))
Call SendMessage(comboCtrl, %CB_SETCURSEL, 0, 0)

If cbListCount > 19 Then 'only keep items 0 to 19 (20 items) in store here
Call SendMessage(comboCtrl, %CB_DELETESTRING, cbListCount, 0)
End If
End If
End Sub

'------------------------------------------------------------------------------
'
'------------------------------------------------------------------------------
Function SearchFindDlgProc(ByVal hDlg As Long, ByVal wMsg As Long, _
ByVal wParam As Long, ByVal lParam As Long) As Long

Static bButnFind As Long
Static bTextFind As Long
Static szFindtxt As Asciiz *255
Static bDirection As Long
Static bmCase As Long
Static bWhole As Long
Static sfindtxt As String

Select Case wMsg

'---
Case %WM_INITDIALOG

bTextFind = GetDlgItem( hDlg,%IDC_FIND_COMBOBOX1 ) 'hWnd combobox1
bButnFind = GetDlgItem( hDlg,%IDC_FIND_BUTTON1 ) 'hWnd Find Next button

' set the options...
If gbFindDir = 0 Then
Call CheckDlgButton( hDlg,%IDC_FIND_RADIO2, %BST_CHECKED) 'down radio button
Else
Call CheckDlgButton( hDlg,%IDC_FIND_RADIO1, %BST_CHECKED) 'up radio button
End If
If gbFindMcase = 1 Then
Call CheckDlgButton( hDlg,%IDC_FIND_CHECK2, %BST_CHECKED) 'Match case
End If
If gbFindWhole = 1 Then
Call CheckDlgButton( hDlg,%IDC_FIND_CHECK1, %BST_CHECKED) 'Match whole word
End If

'CALL CenterWindow( hDlg )

'---need to add the items to the combobox here...
For i& = 0 To UBound(gFindTxt) 'Loop through existing items
Call SendMessage( GetDlgItem(hDlg,%IDC_FIND_COMBOBOX1), %CB_ADDSTRING, i&, StrPtr(gFindTxt(i&)))
Next
'---

'get any selected text in the edm32 control
sfindtxt = edmTxtGetSelText(ghEdit,1)
If sfindtxt <> "" Then
Local CleanWord As Long
CleanWord = InStr(sfindtxt, $CrLf) ' no line feeds here, please
If CleanWord Then sfindtxt = Left$(sfindtxt,CleanWord - 1)
Call SetWindowText( bTextFind, ByVal StrPtr(sfindtxt))
Call EnableWindow( bButnFind, %TRUE)
End If

Function = 1

'---
Case %WM_COMMAND
Select Case LoWrd(wParam)

Case %IDCANCEL 'ID default behavior
If HiWrd(wParam) = %BN_CLICKED Then
Call SendMessage( hDlg, %WM_CLOSE, 0, 0)
End If

Case %IDC_FIND_COMBOBOX1 'ID combobox
Local tLen As Long
Select Case HiWrd(wParam)
Case %CBN_SELENDOK '<- check if selection was made
tLen = SendMessage(GetDlgItem(hDlg,%IDC_FIND_COMBOBOX1), %CB_GETCURSEL, 0, 0)
tLen = SendMessage(GetDlgItem(hDlg,%IDC_FIND_COMBOBOX1), %CB_GETLBTEXTLEN, tLen, 0)
If tLen Then
Call EnableWindow( bButnFind, %TRUE)
Else
Call EnableWindow( bButnFind, %FALSE)
End If
Case %CBN_EDITUPDATE '<- after change, check to see if text exists
tLen = SendMessage(GetDlgItem(hDlg,%IDC_FIND_COMBOBOX1), %WM_GETTEXTLENGTH, 0, 0)
If tLen Then
Call EnableWindow(bButnFind, %TRUE)
Else
Call EnableWindow(bButnFind, %FALSE)
End If
End Select

Case %IDC_FIND_CHECK1 'ID checkbox1 Match whole
If HiWrd(wParam) = %BN_CLICKED Then
bWhole = bWhole Xor %TRUE
End If
Case %IDC_FIND_CHECK2 'ID checkbox2 Match case
If HiWrd(wParam) = %BN_CLICKED Then
bmCase = bmCase Xor %TRUE
End If
Case %IDC_FIND_RADIO1 'ID radiobutton1 Up
If HiWrd(wParam) = %BN_CLICKED Then
bDirection = 1
End If
Case %IDC_FIND_RADIO2 'ID radiobutton2 Down
If HiWrd(wParam) = %BN_CLICKED Then
bDirection = 0
End If

Case %IDC_FIND_BUTTON1 'ID Find Next button
If HiWrd(wParam) = %BN_CLICKED Then
Local Pos As Long
Call GetWindowText(bTextFind, szFindtxt, SizeOf(szFindtxt))

' Load up global variables for Find Next function
sfindtxt = szFindtxt
gFindNextTxt = szFindtxt
gbFindDir = bDirection
gbFindMCase = bmCase
gbFindWhole = bWhole

Pos = edmTxtFindNext(ghEdit, sfindtxt, bDirection, bmCase, bWhole, 1)


Call UpdateComboList(hDlg,%IDC_FIND_COMBOBOX1, sfindtxt)

If Pos = 0 Then
Call EnableWindow( GetParent(hDlg), %FALSE)
If IsTrue(ghReplaceDlg) Then EnableWindow ghReplaceDlg, %FALSE
Call MsgBoxApi( hDlg, "Match not found","Find", %MB_OK Or %MB_APPLMODAL Or %MB_ICONQUESTION)
Call EnableWindow( GetParent(hDlg), %FALSE)
If IsTrue(ghReplaceDlg) Then EnableWindow ghReplaceDlg, %TRUE
Call EnableWindow( GetParent(hDlg), %TRUE)
End If
End If

Case %IDC_FIND_BUTTON2 'ID button close
If HiWrd(wParam) = %BN_CLICKED Then
Call SendMessage( hDlg, %WM_CLOSE, 0, 0)
End If

End Select

'---
Case %WM_CLOSE

'---
'Save the combo list to a global array, since the control will be destroyed
'Note, could also save the words to a file that is loaded next time program
'is started. This said as a tip for ev. enhancements..
Local cb As Long, cbCount As Long, cbLen As Long
cbCount = SendMessage(GetDlgItem(hDlg,%IDC_FIND_COMBOBOX1), %CB_GETCOUNT, 0, 0)
If cbCount Then
ReDim gFindTxt(cbCount - 1)
For cb = 0 To cbCount - 1 'Loop through existing items
cbLen = SendMessage(GetDlgItem(hDlg,%IDC_FIND_COMBOBOX1), %CB_GETLBTEXTLEN, cb, 0)
gFindTxt(cb) = Space$(cbLen + 1)
Call SendMessage(GetDlgItem(hDlg,%IDC_FIND_COMBOBOX1), %CB_GETLBTEXT, cb, StrPtr(gFindTxt(cb)))
gFindTxt(cb) = Left$(gFindTxt(cb), Len(gFindTxt(cb)) -1)
Next
End If
'---
Call DestroyWindow(hDlg)

'---
Case %WM_DESTROY
ghFindDlg = 0 'clear this handle
Call SetFocus(ghEdit)

End Select

End Function

'------------------------------------------------------------------------------
'
'------------------------------------------------------------------------------
Function SearchReplaceDlgProc(ByVal hDlg As Long, ByVal wMsg As Long, _
ByVal wParam As Long, ByVal lParam As Long) As Long

Static btnFind As Long
Static btnReplace As Long
Static btnReplaceAll As Long
Static txtFind As Long
Static txtReplace As Long
Static Searchtxt As Asciiz*255
Static Replacetxt As Asciiz*255
Static mCase As Long
Static whole As Long
Static rt As String
Static ft As String

Select Case wMsg

'---
Case %WM_INITDIALOG

txtFind = GetDlgItem(hDlg,%IDC_REPLACE_COMBOBOX1) 'hWnd editbox1, find what
txtReplace = GetDlgItem(hDlg,%IDC_REPLACE_COMBOBOX2) 'hWnd editbox2, replace with
btnFind = GetDlgItem(hDlg,%IDC_REPLACE_BUTTON1) 'hWnd button1, find next
btnReplace = GetDlgItem(hDlg,%IDC_REPLACE_BUTTON2) 'hWnd button2, replace
btnReplaceAll = GetDlgItem(hDlg,%IDC_REPLACE_BUTTON3) 'hWnd button3, replace all

'CALL CenterWindow( hDlg )

' set the options...
If gbRepmCase = 1 Then
Call CheckDlgButton( hDlg,%IDC_REPLACE_CHECK2, %BST_CHECKED) 'Match case
End If
If gbRepWhole = 1 Then
Call CheckDlgButton( hDlg,%IDC_REPLACE_CHECK1, %BST_CHECKED) 'Match whole word
End If

'---need to add the items to the combobox here...
For i& = 0 To UBound(gFindRepTxt) 'Loop through existing items
Call SendMessage( GetDlgItem(hDlg,%IDC_REPLACE_COMBOBOX1), %CB_ADDSTRING, i&, StrPtr(gFindRepTxt(i&)))
Next
For i& = 0 To UBound(gRepWithTxt) 'Loop through existing items
Call SendMessage( GetDlgItem(hDlg,%IDC_REPLACE_COMBOBOX2), %CB_ADDSTRING, i&, StrPtr(gRepWithTxt(i&)))
Next
'---

ft = edmTxtGetSelText(ghEdit,1)
If ft <> "" Then
Local CleanWord As Long
CleanWord = InStr(ft, $CrLf) ' no line feeds here, please
If CleanWord Then ft = Left$(ft,CleanWord - 1)
Call SetWindowText( txtFind, ByVal StrPtr(ft))
Call EnableWindow( btnFind, %TRUE)
Call EnableWindow( btnReplace, %TRUE)
Call EnableWindow( btnReplaceAll, %TRUE)
End If

Function = 1

'---
Case %WM_COMMAND
Select Case LoWrd(wParam)

Case %IDCANCEL 'default Esc key

If HiWrd(wParam) = %BN_CLICKED Then
Call SendMessage( hDlg, %WM_CLOSE , 0, 0)
End If

Case %IDC_REPLACE_COMBOBOX1 'ID combobox
Local tLen As Long
Local bStatus As Long
Select Case HiWrd(wParam)
Case %CBN_SELENDOK '<- check if selection was made
tLen = SendMessage(GetDlgItem(hDlg,%IDC_REPLACE_COMBOBOX1), %CB_GETCURSEL, 0, 0)
tLen = SendMessage(GetDlgItem(hDlg,%IDC_REPLACE_COMBOBOX1), %CB_GETLBTEXTLEN, tLen, 0)
If tLen Then bStatus = %TRUE Else bStatus = %FALSE
Call EnableWindow( btnFind, bStatus)
Call EnableWindow( btnReplace, bStatus)
Call EnableWindow( btnReplaceAll, bStatus)
Case %CBN_EDITUPDATE '<- after change, check to see if text exists
tLen = SendMessage(GetDlgItem(hDlg,%IDC_REPLACE_COMBOBOX1), %WM_GETTEXTLENGTH, 0, 0)
If tLen Then bStatus = %TRUE Else bStatus = %FALSE
Call EnableWindow( btnFind, bStatus)
Call EnableWindow( btnReplace, bStatus)
Call EnableWindow( btnReplaceAll, bStatus)
End Select

Case %IDC_REPLACE_CHECK1 ' ID checkbox1, match whole
If HiWrd(wParam) = %BN_CLICKED Then
whole = whole Xor %TRUE
End If
Case %IDC_REPLACE_CHECK2 ' ID checkbox2, match case
If HiWrd(wParam) = %BN_CLICKED Then
mCase = mCase Xor %TRUE
End If

Case %IDC_REPLACE_BUTTON1 ' ID button1, find next
If HiWrd(wParam) = %BN_CLICKED Then
Local Pos As Long
GetWindowText txtFind, Searchtxt, SizeOf(Searchtxt)
ft = Searchtxt
Pos = edmTxtFindNext(ghEdit, ft, 0, mCase, whole, 1)

Call UpdateComboList(hDlg,%IDC_REPLACE_COMBOBOX1, ft)

If Pos = 0 Then
'-disable replace button
Call EnableWindow( btnReplace, %FALSE)
Call EnableWindow( GetParent(hDlg), %FALSE)
If IsTrue(ghFindDlg) Then Call EnableWindow( ghFindDlg, %FALSE)
Call MsgBoxApi( hDlg, "Match not found","Replace", %MB_OK Or %MB_APPLMODAL Or %MB_ICONQUESTION)
If IsTrue(ghFindDlg) Then Call EnableWindow( ghFindDlg, %TRUE)
Call EnableWindow( GetParent(hDlg), %TRUE)
Else
'-enable replace button
Call EnableWindow( btnReplace, %TRUE)
End If
End If

Case %IDC_REPLACE_BUTTON2 'ID button2, replace
If HiWrd(wParam) = %BN_CLICKED Then
'get the text string to replace
Call GetWindowText( txtReplace,Replacetxt,SizeOf(Replacetxt))
rt = Replacetxt

Call UpdateComboList(hDlg,%IDC_REPLACE_COMBOBOX2, rt)

'replace the selected text...
Call SendMessage(ghEdit,%EDM_REPLACESEL,ByVal StrPtr(rt), %TRUE)
'find the next instance to replace...
Call SendMessage(hDlg,%WM_COMMAND,MakLng(%IDC_REPLACE_BUTTON1,0),GetDlgItem(hDlg,%IDC_REPLACE_BUTTON1))
End If

Case %IDC_REPLACE_BUTTON3 'ID button3, replace all
If HiWrd(wParam) = %BN_CLICKED Then
Local count As Long
Call GetWindowText(txtFind,Searchtxt,SizeOf(Searchtxt))
Call GetWindowText(txtReplace,Replacetxt,SizeOf(Replacetxt))
ft = Searchtxt
rt = Replacetxt
count = edmTxtReplaceAll(ghEdit, ft, rt, mCase, whole, 0)
'-disable replace button
Call EnableWindow(btnReplace, %FALSE)
If count = 0 Then
Call EnableWindow(GetParent(hDlg), %FALSE)
If IsTrue(ghFindDlg) Then Call EnableWindow( ghFindDlg, %FALSE)
MsgBoxApi hDlg, "Match not found","Replace", %MB_OK Or %MB_APPLMODAL Or %MB_ICONQUESTION
If IsTrue(ghFindDlg) Then Call EnableWindow( ghFindDlg, %TRUE)
Call EnableWindow(GetParent(hDlg), %TRUE)
End If
End If

Case %IDC_REPLACE_BUTTON4 ' ID button4, close
If HiWrd(wParam) = %BN_CLICKED Then
Call SendMessage( hDlg, %WM_CLOSE, 0, 0)
End If

End Select

'---
Case %WM_CLOSE
'---
'Save the combo list to a global array, since the control will be destroyed
'Note, could also save the words to a file that is loaded next time program
'is started. This said as a tip for ev. enhancements..
Local cb As Long, cbCount As Long, cbLen As Long
cbCount = SendMessage(GetDlgItem(hDlg,%IDC_REPLACE_COMBOBOX1), %CB_GETCOUNT, 0, 0)
If cbCount Then
ReDim gFindRepTxt(cbCount - 1)
For cb = 0 To cbCount - 1 'Loop through existing items
cbLen = SendMessage(GetDlgItem(hDlg,%IDC_REPLACE_COMBOBOX1), %CB_GETLBTEXTLEN, cb, 0)
gFindRepTxt(cb) = Space$(cbLen + 1)
Call SendMessage(GetDlgItem(hDlg,%IDC_REPLACE_COMBOBOX1), %CB_GETLBTEXT, cb, StrPtr(gFindRepTxt(cb)))
gFindRepTxt(cb) = Left$(gFindRepTxt(cb), Len(gFindRepTxt(cb)) -1)
Next
End If
cbCount = SendMessage(GetDlgItem(hDlg,%IDC_REPLACE_COMBOBOX2), %CB_GETCOUNT, 0, 0)
If cbCount Then
ReDim gRepWithTxt(cbCount - 1)
For cb = 0 To cbCount - 1 'Loop through existing items
cbLen = SendMessage(GetDlgItem(hDlg,%IDC_REPLACE_COMBOBOX2), %CB_GETLBTEXTLEN, cb, 0)
gRepWithTxt(cb) = Space$(cbLen + 1)
Call SendMessage(GetDlgItem(hDlg,%IDC_REPLACE_COMBOBOX2), %CB_GETLBTEXT, cb, StrPtr(gRepWithTxt(cb)))
gRepWithTxt(cb) = Left$(gRepWithTxt(cb), Len(gRepWithTxt(cb)) -1)
Next
End If
'---
Call DestroyWindow(hDlg)

'---
Case %WM_DESTROY
ghReplaceDlg = 0 'clear exist handle
Call SetFocus(ghEdit)

End Select

End Function

'------------------------------------------------------------------------------
'
'------------------------------------------------------------------------------
Function GotoLineDlgProc(ByVal hDlg As Long, ByVal wMsg As Long, _
ByVal wParam As Long, ByVal lParam As Long) As Long

Static gotoEdit As Long
Static lblLast As Long
Static lblCurr As Long
Static btnOK As Long
Local GotoLine As Asciiz *255

Select Case wMsg

'---
Case %WM_INITDIALOG
gotoEdit = GetDlgItem(hDlg,%IDC_GOTO_EDITBOX1) 'hWnd editbox1, goto line
lblLast = GetDlgItem(hDlg,%IDC_GOTO_LABEL2) 'hWnd label1, last line
lblCurr = GetDlgItem(hDlg,%IDC_GOTO_LABEL4) 'hWnd label2, current line
btnOK = GetDlgItem(hDlg,%IDC_GOTO_BUTTON1) 'hWnd button1, ok

'CALL CenterWindow(hDlg)

Call SetWindowText(lblLast,Str$(SendMessage(ghEdit,%EDM_GETLINECOUNT,0,0)))
Call SetWindowText(lblCurr,Str$(SendMessage(ghEdit,%EDM_GETCARETY,0,0) + 1))

Function = 1

'---
Case %WM_COMMAND
Select Case LoWrd(wParam)

Case %IDCANCEL 'default Esc key...

If HiWrd(wParam) = %BN_CLICKED Then
Call SendMessage( hDlg, %WM_CLOSE, 0, 0 )
End If

Case %IDOK, %IDC_GOTO_BUTTON1 'default Return, and ID button1 OK...
If HiWrd(wParam) = %BN_CLICKED Then
Call GetWindowText( gotoEdit, GotoLine, SizeOf(GotoLine))
Call SendMessage( ghEdit, %EDM_GOTOLINE, Val(GotoLine), %TRUE)
Call SendMessage( hDlg, %WM_CLOSE, 0, 0)
End If

Case %IDC_GOTO_EDITBOX1 'ID editbox1, go to line
Select Case HiWrd(wParam)
Case %EN_CHANGE
Call GetWindowText( gotoEdit, GotoLine, SizeOf(GotoLine))
If Val(GotoLine) <= SendMessage(ghEdit, %EDM_GETLINECOUNT, 0, 0) + 1 Then
Call EnableWindow( btnOK, %TRUE)
Else
Call EnableWindow( btnOK, %FALSE)
End If
If GotoLine = "" Then Call EnableWindow( btnOK, %FALSE)
End Select

Case %IDC_GOTO_BUTTON2 'ID close button
If HiWrd(wParam) = %BN_CLICKED Then
Call SendMessage( hDlg, %WM_CLOSE, 0, 0)
End If

End Select

'---
Case %WM_CLOSE
Call EndDialog( hDlg, 1)

'---
Case %WM_DESTROY
Call SetFocus(ghEdit)

End Select

End Function
